# Method: projects.locations.productSets.products.list

- [HTTP request](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.request_body)
- [Response body](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.ListProductsInProductSetResponse.SCHEMA_REPRESENTATION)
- [Authorization Scopes](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.productSets.products/list#body.aspect)

Lists the Products in a ProductSet, in an unspecified order. If the ProductSet does not exist, the products field of the response will be empty.

Possible errors:

- Returns INVALID_ARGUMENT if pageSize is greater than 100 or less than 1.

### HTTP request

`GET https://vision.googleapis.com/v1p3beta1/{name=projects/*/locations/*/productSets/*}/products`

The URL uses [gRPC Transcoding](https://github.com/googleapis/googleapis/blob/master/google/api/http.proto) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` The ProductSet resource for which to retrieve Products. Format is: `projects/PROJECT_ID/locations/LOC_ID/productSets/PRODUCT_SET_ID` <br /> |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `number` The maximum number of items to return. Default 10, maximum 100. |
| `pageToken` | `string` The nextPageToken returned from a previous List request, if any. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:
Response message for the `products.list` method.

| JSON representation ||
|---|---|
| ``` { "products": [ { object(`https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.products#Product`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `products[]` | ``object(`https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1p3beta1/projects.locations.products#Product`)`` The list of Products. |
| `nextPageToken` | `string` Token to retrieve the next page of results, or empty if there are no more results in the list. |

### Authorization Scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/cloud-vision`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).